<%@ page import="java.util.*,java.io.*,java.text.SimpleDateFormat,java.net.URL"%>


<%!

  // ---------------------------------------------------------------------------------------------------
  // -- CUSTOMIZATION SECTION - USE THESE FIELDS TO CUSTOMIZE YOUR FORTUNE  -------------------------
  // ---------------------------------------------------------------------------------------------------
  
  public static final String CFG_FILE = "C:\\fortune.cfg";

  // ---------------------------------------------------------------------------------------------------
  // -- END OF CUSTOMIZATION SECTION  ------------------------------------------------------------------
  // ---------------------------------------------------------------------------------------------------
%>


<%!

  public static class Entry {
    public File file;
    public int nbMessages;
    public String toString() {
      return "\n{"+file+","+nbMessages+"}";
    }
  }

  public static final Object LOCK = new Object();
  public static final ArrayList fileList = new ArrayList();
  public static int totalMessages;
  public static boolean initialized;
  public static Throwable initError;

  static {
    try {
      File config = new File(CFG_FILE).getAbsoluteFile();
      if (config.exists()) {
        initMessages(config);
        initialized = true;
      } else throw new Exception("File "+config+" does not exist");
    } catch (Exception e) {
      initError = e;
      initialized = false;
    }
  }
  
  
  public static void initMessages(File cfgFile) throws Exception {
    FileReader fr = null;
    try {
      BufferedReader in = new BufferedReader(fr=new FileReader(cfgFile));
      totalMessages=0;
      while (true) {
        String line = in.readLine();
        if (line==null) break;
        File f = new File(line);
        if (f.exists()) initMessageFile(f);
      }
    } finally {
      if (fr!=null) try { fr.close(); } catch (Exception e) {}
    }
  }
  
  public static void initMessageFile(File fortuneFile) throws Exception {
    FileReader fr = null;
    try {
      BufferedReader in = new BufferedReader(fr=new FileReader(fortuneFile));
      int msg = 0;
      boolean inMsg = false;
      String message="";
      while (true) {
        String line = in.readLine();
        if (line==null) break;
        if (line.equals("%") || line.equals("%%")) inMsg=false;
        else {
          if (!inMsg) {
            inMsg=true;
            msg++;
            message="";
          }
          if (message.length()==0) message=line;
          else message+="\n"+line;
        }
      }
      if (msg!=0) {
        if (message.length()<2) msg--;
        Entry e = new Entry();
        e.file = fortuneFile;
        e.nbMessages = msg;
        fileList.add(e);
        totalMessages += msg;
      }
    } finally {
      if (fr!=null) try { fr.close(); } catch (Exception e) {}
    }
  }
  
  
  public static String replace(String str, String oldValue, String newValue) {
    int index = str.indexOf(oldValue);

    if (index == -1)
      return str;
    else {
      int oldValueLen = oldValue.length();
      int indexRemaining = 0;
      StringBuffer result = new StringBuffer();

      while (index != -1) {
        result.append(str.substring(indexRemaining, index));
        result.append(newValue);
        index = str.indexOf(oldValue, indexRemaining = index + oldValueLen);
      }
      result.append(str.substring(indexRemaining));
      return result.toString();
    }
  }


  /**
   *  returns an HTML-valid version of this String. (ie: all specials characters
   *  like &amp;, &lt;... are replaced by their corresponding HTML entities)
   *
   * @param  arg  The String to be processed
   * @return      The valid HTML String.
   */
  public static String formatForHTML(String arg) {
    if (arg == null)
      return "";
    return replace(replace(replace(replace(arg, "&", "&amp;"), "\"", "&quot;"), ">", "&gt;"), "<", "&lt;");
  }


  /**
   *  returns an JavaScript-valid version of this String. (ie: all specials
   *  characters like &quot;, \... are replaced by their corresponding
   *  Javascript String syntax equivalent)
   *
   * @param  arg  Description of the Parameter
   * @return      Description of the Return Value
   */
  public static String formatForJavascriptString(String arg) {
    if (arg == null)
      return "";
    return replace(replace(replace(replace(replace(arg, "\\", "\\\\"), "\r", "\\r"), "\n", "\\n"), "\"", "\\\""), "'", "\\'");
  }
  
  public static int getIndex(String s, int base, int offset) {
/*System.out.println("getIndex('"+replace(s,"\b","~")+"',"+base+","+offset+")=");
System.out.print("          ");
for (int xx=0 ; xx<base ; xx++) System.out.print(" ");
System.out.println("^");*/
    int target = base + offset;
    int realIndex = base;
    if (offset>0) {
      while (base!=target) {
        realIndex++;
        base++;
        if (s.charAt(realIndex)=='<') {
          while (s.charAt(realIndex) != '>') realIndex++;
          base--;
        }
        if (s.charAt(realIndex)=='&') {
          while (s.charAt(realIndex) != ';') realIndex++;
        }
      }
    } else
    if (offset<0) {
      while (base!=target) {
        realIndex--;
        base--;
        if (s.charAt(realIndex)=='>') {
          while (s.charAt(realIndex) != '<') realIndex--;
          base++;
        }
        if (s.charAt(realIndex)==';') {
          int temp=realIndex;
          realIndex--;
          while (Character.isLetterOrDigit(s.charAt(realIndex))) realIndex--;
          if (s.charAt(realIndex)=='&') ;
          else realIndex=temp;
        }
      }
    }
/*System.out.print("          ");
for (int xx=0 ; xx<realIndex ; xx++) System.out.print(" ");
System.out.println("X");*/
    return realIndex;
  }
  
  public static String getAccentCharFrom(String testStr) {
    if (testStr.indexOf("/&quot;/")>-1) {
      if (testStr.indexOf("/a/")>-1) return "&auml;";
      if (testStr.indexOf("/e/")>-1) return "&euml;";
      if (testStr.indexOf("/i/")>-1) return "&iuml;";
      if (testStr.indexOf("/o/")>-1) return "&ouml;";
      if (testStr.indexOf("/u/")>-1) return "&uuml;";
      if (testStr.indexOf("/y/")>-1) return "&yuml;";
      if (testStr.indexOf("/A/")>-1) return "&Auml;";
      if (testStr.indexOf("/E/")>-1) return "&Euml;";
      if (testStr.indexOf("/I/")>-1) return "&Iuml;";
      if (testStr.indexOf("/O/")>-1) return "&Ouml;";
      if (testStr.indexOf("/U/")>-1) return "&Uuml;";
      if (testStr.indexOf("/Y/")>-1) return "&Yuml;";
    }
    if (testStr.indexOf("/'/")>-1) {
      if (testStr.indexOf("/a/")>-1) return "&aacute;";
      if (testStr.indexOf("/e/")>-1) return "&eacute;";
      if (testStr.indexOf("/i/")>-1) return "&iacute;";
      if (testStr.indexOf("/o/")>-1) return "&oacute;";
      if (testStr.indexOf("/u/")>-1) return "&uacute;";
      if (testStr.indexOf("/y/")>-1) return "&yacute;";
      if (testStr.indexOf("/A/")>-1) return "&Aacute;";
      if (testStr.indexOf("/E/")>-1) return "&Eacute;";
      if (testStr.indexOf("/I/")>-1) return "&Iacute;";
      if (testStr.indexOf("/O/")>-1) return "&Oacute;";
      if (testStr.indexOf("/U/")>-1) return "&Uacute;";
      if (testStr.indexOf("/Y/")>-1) return "&Yacute;";
    }
    if (testStr.indexOf("/`/")>-1) {
      if (testStr.indexOf("/a/")>-1) return "&agrave;";
      if (testStr.indexOf("/e/")>-1) return "&egrave;";
      if (testStr.indexOf("/i/")>-1) return "&igrave;";
      if (testStr.indexOf("/o/")>-1) return "&ograve;";
      if (testStr.indexOf("/u/")>-1) return "&ugrave;";
      if (testStr.indexOf("/A/")>-1) return "&Agrave;";
      if (testStr.indexOf("/E/")>-1) return "&Egrave;";
      if (testStr.indexOf("/I/")>-1) return "&Igrave;";
      if (testStr.indexOf("/O/")>-1) return "&Ograve;";
      if (testStr.indexOf("/U/")>-1) return "&Ugrave;";
    }
    if (testStr.indexOf("/^/")>-1) {
      if (testStr.indexOf("/a/")>-1) return "&acirc;";
      if (testStr.indexOf("/e/")>-1) return "&ecirc;";
      if (testStr.indexOf("/i/")>-1) return "&icirc;";
      if (testStr.indexOf("/o/")>-1) return "&ocirc;";
      if (testStr.indexOf("/u/")>-1) return "&ucirc;";
      if (testStr.indexOf("/A/")>-1) return "&Acirc;";
      if (testStr.indexOf("/E/")>-1) return "&Ecirc;";
      if (testStr.indexOf("/I/")>-1) return "&Icirc;";
      if (testStr.indexOf("/O/")>-1) return "&Ocirc;";
      if (testStr.indexOf("/U/")>-1) return "&Ucirc;";
    }
    if (testStr.indexOf("/,/")>-1) {
      if (testStr.indexOf("/c/")>-1) return "&ccedil;";
      if (testStr.indexOf("/C/")>-1) return "&Ccedil;";
    }
    if (testStr.indexOf("/~/")>-1) {
      if (testStr.indexOf("/n/")>-1) return "&ntilde;";
      if (testStr.indexOf("/N/")>-1) return "&Ntilde;";
      if (testStr.indexOf("/a/")>-1) return "&atilde;";
      if (testStr.indexOf("/A/")>-1) return "&Atilde;";
    }
    if (testStr.indexOf("///")>-1) {
      if (testStr.indexOf("/o/")>-1) return "&oslash;";
      if (testStr.indexOf("/O/")>-1) return "&Oslash;";
    }
    if (testStr.indexOf("//")>-1) {
      if (testStr.indexOf("/a/")>-1) return "&aring;";
      if (testStr.indexOf("/A/")>-1) return "&Aring;";
    }
    if (testStr.indexOf("/a/")>-1) {
      if (testStr.indexOf("/e/")>-1) return "&aelig;";
    }
    if (testStr.indexOf("/A/")>-1) {
      if (testStr.indexOf("/E/")>-1) return "&AElig;";
    }
    return null;
  }
  
  
  
  public static String formatForEntry(String arg) {
    if (arg == null)
      return "";
    String res = replace(replace(arg, "\r", " "), "\n", "<BR>") + "  ";
    String resBackup = res;

    try {
      int index;
      while ((index=res.indexOf('\b'))>-1) {
        int length = 1;
        while (res.charAt(index+length)=='\b') length++;
        char lastChar = res.charAt(getIndex(res,index,-1));
        if (length==1) {
          while (res.charAt(index+length*2)=='\b') length++;
          if (length>1) index+=length-1;
        }
        String concernedString = res.substring(/*getIndex(res,index,length)*/index+length,getIndex(res,index,length*2));
        String firstString = res.substring(getIndex(res,index,-1),index);
        String testStr = "/"+firstString+"/"+concernedString+"/";
        String accent = getAccentCharFrom(testStr);
        if (accent!=null) {
          concernedString = accent;
          lastChar='\u0000';
        }
        switch (lastChar) {
          case '_' :
            res = res.substring(0,getIndex(res,index,-length)) + "<U>" + concernedString + "</U>" + res.substring(getIndex(res,index,length*2));
            break;
          case '\u0000' :
            res = res.substring(0,getIndex(res,index,-length)) + concernedString + res.substring(getIndex(res,index,length*2));
            break;
          default :
            res = res.substring(0,getIndex(res,index,-length)) + "<B>" + concernedString + "</B>" + res.substring(getIndex(res,index,length*2));
            break;
        }
  
      }
    } catch (Exception e) {
      res = resBackup;
      int index;
      while ((index=res.indexOf('\b'))>-1) {
        if (index==0) res=res.substring(1);
        else
          res = res.substring(0,index-1) + res.substring(index+1);
      }
    }
    return res;
  }

  
  
  public static String getMessageText(File fortuneFile, int num) throws Exception {
    FileReader fr = null;
    try {
      BufferedReader in = new BufferedReader(fr=new FileReader(fortuneFile));
      int msg = 0;
      String message="";
      boolean inMsg = false;
      while (true) {
        String line = in.readLine();
        if (line==null) {
          if (message.length()>0) return message;
          break;
        }
        if (line.equals("%") || line.equals("%%")) inMsg=false;
        else {
          if (!inMsg) {
            inMsg=true;
            msg++;
          }
          if (msg==num) {
            if (message.length()==0) message=line;
            else message+="\n"+line;
          } else if (msg>num) return message;
        }
      }
    } finally {
      if (fr!=null) try { fr.close(); } catch (Exception e) {}
    }
    return "error looking in msg " + num + " in file " + fortuneFile + "\n" + fileList;
  }
  
  public String getMessageText(int num) {
    int index=0;
    try {
      while (true) {
        Entry e = (Entry)fileList.get(index);
        if (num<=e.nbMessages)
          return getMessageText(e.file,num);
        else
          num-=e.nbMessages;
        index++;
      }
    } catch (Exception e) {
      return e.toString();
    }
  }
  
  public String pickMessage(HttpServletRequest req, boolean numbers) {
    String requestedMsg = req.getParameter("fortunemsg");
    //System.out.println(requestedMsg);
    int msgNum = -1;
    if (requestedMsg!=null) {
      try {
        msgNum = Integer.parseInt(requestedMsg);
      } catch (Exception e) {}
    }
    if (msgNum == -1) {
      double factor = totalMessages+1;
      factor*=Math.random();
      msgNum = (int)Math.floor(factor);
    }
    if (numbers)
      return formatForEntry(formatForHTML(msgNum + " / " + totalMessages + "\n\n" + getMessageText(msgNum)));
    else
      return formatForEntry(formatForHTML(getMessageText(msgNum)));
  }
%>

<%!
  String getFortuneMessage(HttpServletRequest request, boolean numbers) {
      if (initialized) {
        return "<PRE>" + pickMessage(request,numbers) + "</PRE>";
      } else { // NOT initialized
        return "There was a problem initializing the Fortune JSP." + 
               "<BR><PRE>"+initError+"</PRE>";
      } // NOT initialized END
  }

%>

<%= getFortuneMessage(request,false) %>
